from django.db import models

# abstract super-class for methods of model-classes
class MyModel(models.Model):
    def __unicode__(self):  # define result of 'unicode()'
        return self.name

    def getAlnum(self):     # remove all non-alphanumeric chars from object-name
        return ''.join(char for char in self.name if char.isalnum())

    class Meta:             # define Model abstract
        abstract = True
    

# Model for bands
class Band(MyModel):
    name = models.CharField(max_length=50, unique=True)
    genre = models.CharField(max_length=50)
    formed_in = models.IntegerField()
    origin = models.CharField(max_length=50)
    website = models.URLField(blank=True)

# Model for albums
class Album(MyModel):
    name = models.CharField(max_length=50)
    year = models.IntegerField()
    band = models.ForeignKey('Band')

# Model for songs
class Song(models.Model):
    title = models.CharField(max_length=50)
    length = models.CharField(max_length=5)
    album = models.ForeignKey('Album')
    number = models.IntegerField()

    def __unicode__(self):
        return self.title
