# import django-modules
from django.shortcuts import render_to_response
from django.http import Http404
# import models
from models import *


# find object by its alphanumeric name
def objectFromAlnum(model, alnumName):
    for item in eval(model).objects.all():
        if item.getAlnum() == alnumName:
            return item


# view for the band-overview
def root(request):
    bands = Band.objects.all().order_by('name')
    return render_to_response('root.html', {'bands': bands})

# view for band-details
def band(request, bandAlnum):
    theBand = objectFromAlnum('Band', bandAlnum)
    if not theBand:
        raise Http404
    
    albums = Album.objects.filter(band=theBand).order_by('year')
        
    return render_to_response('band.html', {'band': theBand, 'albums': albums})

# view for album-details
def album(request, bandAlnum, albumAlnum):
    theBand = objectFromAlnum('Band', bandAlnum)
    theAlbum = objectFromAlnum('Album', albumAlnum)
        
    if not (theAlbum and theBand):
        raise Http404

    songs = Song.objects.filter(album=theAlbum).order_by('number')

    return render_to_response('album.html', {'band': theBand, 'album': theAlbum, 'songs': songs})
